#ifndef N2NC_NETADDRESS_H
#define N2NC_NETADDRESS_H

#include "nixsys.h"
#include "socketaddress.h"

namespace n2nc {
namespace net {

class IP4Address;
class IP6Address;


/**
  \brief Provides the abstraction to implements various address family addresses.
  @author fabsoft <fabsoft@gmail.com>
*/
class Address{
protected:
    Address();
    int m_af;
public:
    ~Address();
    /** \brief (Factory method)
        @return A new Address by specified \a addr in string format
     */
    static Address* newAddress(std::string &addr) ; /**< \callgraph */

    /** @return the address family in OS defined format */
    int getAddressFamily() const;
    /** @return the address in string format */
    virtual std::string toString() const =0 ;
    
    /** @return a pointer to the internal sockaddr* and sets its lenght */
    virtual void getRawAddress(void **addr,size_t *len)=0;
//     virtual SocketAddress& getSocketAddress()=0;


};

}
}


// #include "ip4address.h"
// #include "ip6address.h"

#endif
