#ifndef N2NC_UTILS_ARGSARGUMENT_H
#define N2NC_UTILS_ARGSARGUMENT_H

#include "nixsys.h"
#include "validargument.h"

namespace n2nc {
namespace utils {
namespace args {

using namespace std ;
/**
  \brief This class represent a already istanciated argument

  @author fabsoft <fabsoft@gmail.com>
*/
class Argument{
  public:
    /** Creates a new argument, but leave it unchecked */
    Argument(string name,string param);
    ~Argument();
    /** check if the argument has valid name and parameter */
    bool validate(std::vector<ValidArgument>& validargs) throw(/* FIXME thrown something please */) ;
      /** Tests if the dependencies arguments are satisfied. */
      bool checkForDependecies(vector<Argument>& args);
      /** Tests if there some conflictual argument.\return true if no conflicts are checked. */
      bool checkForConflicts(vector<Argument>& args);
      /** Tests if the given paramenter is valid. */
//       bool checkForParam(string param);
//       /** Tests if the given name is valid. */
//       bool checkForName(string name);
    
    
    string toString();
    /** \return The parameter */
    string param();
    
  private:
    ValidArgument *m_validarg ;
    std::string m_name ;
    std::string m_param ;
  
  friend class ArgumentsHelper ;
};

}
}
}

#endif
