#ifndef N2NC_UTILS_ARGSARGUMENTSHELPER_H
#define N2NC_UTILS_ARGSARGUMENTSHELPER_H

#include "nixsys.h"
#include "validargument.h"
#include "argument.h"

namespace n2nc {
namespace utils {
namespace args {

using namespace std ;

/**
  \brief This class provides a helper/utility to handle command line argumets

  This utility handle dependencies and conflicts arguments

  @author fabsoft <fabsoft@gmail.com>
*/
class ArgumentsHelper{
  public:
    ArgumentsHelper(char** args, int argc/*, vector<ValidArgument>& validargs*/ );
    ~ArgumentsHelper();

    ValidArgument* addValid(string name);
    /** validates all.\note default parameters will be setted up HERE. */
    bool validate() ;
    int size();
    Argument* getArgumentByName(string name)throw(/*FIXME*/) ;
    Argument* operator[](string name)throw(/*FIXME*/) ;
    string toString();
    string dumpAllValid();
    string getRawArg(int pos);
    string getFreeArg(int pos);
    
  private:
    vector<Argument> m_arguments ;
    vector<ValidArgument> m_validargs ;
    vector<string> m_freeargs ;
    char** m_argv ;

  /**
    \example argument_ex.cpp An example of using this helper. The output is \code COOD \endcode
  */
};

}
}
}

#endif
