#ifndef N2NC_SECURITYBLOWFISH_H
#define N2NC_SECURITYBLOWFISH_H

#include "nixsys.h"

namespace n2nc {
namespace security {

/**
	@author fabsoft <fabsoft@gmail.com>
*/
class BlowFish{
  public:
    struct key_t{   u_char key[16]; u_char iv[8] ;};
    
    BlowFish(key_t *key);
    
    int encrypt(void* inbuf, void* outbuf, size_t inlen);
    int decrypt(void* inbuf, void* outbuf, size_t inlen);
    int reinit();
    int loadKey(key_t *key);
    
    static int keyRand(key_t *key);
    ~BlowFish();
  
    key_t nullkey ;
  private:
    
    EVP_CIPHER_CTX m_ctx;
    EVP_CIPHER_CTX m_ctx_e;
    EVP_CIPHER_CTX m_ctx_d;
    unsigned char m_key[16];
    unsigned char m_iv[8];

};

}
}

#endif
