#include "clientinfo.h"

namespace n2nc {

ClientInfo::ClientInfo(ClientID id, net::Socket *sk){
//   this->m_rsakey = new n2nc::security::Rsa(/*id*/); /*FIXME*/
  this->m_ctlsk = sk ;
  this->m_last_ack_time = time(NULL);
  this->m_id = id;
  this->m_rsakey = NULL ;
  this->m_srv_sockaddr = NULL ;
  
}

ClientInfo::~ClientInfo(){
  if (this->m_rsakey)
    delete this->m_rsakey ;
  if (this->m_srv_sockaddr)
    delete this->m_srv_sockaddr ;
}

time_t ClientInfo::setAckTime(){
  this->m_last_ack_time = time(NULL);
}

bool ClientInfo::checkStatus(){
  return (time(NULL) - this->m_last_ack_time) < N2NCCLIENTINFO_CLIENT_TIMEOUT ;

}

int ClientInfo::setServicePort(uint16_t port){
  this->m_sport = port ;
}

uint16_t ClientInfo::getServicePort(){
  return this->m_sport ;
}

uint32_t ClientInfo::getKeyID(){
//   return this->m_rsakey->getID();
  return this->m_id ;
  return 0 ;
}


net::Socket *ClientInfo::getCtlSock(){
  return this->m_ctlsk ;
}

net::SocketAddress *ClientInfo::getSrvSocketAddr(){
net::SocketAddress *sa, *sa2 ;
net::Address *addr ;
  
  if (!this->m_sport) return NULL;
  if (!this->m_srv_sockaddr){
    /* retrieve service socket address */
    sa2 = this->m_ctlsk->getRemoteSocketAddress() ;
    addr = sa2->getAddress();
    sa = net::Resolver::getSocketAddressByService(*addr,this->m_sport ,SOCK_DGRAM);
    this->m_srv_sockaddr = sa ;
    delete sa2 ;
    delete addr ;
  }
  
  return this->m_srv_sockaddr ;
}


}





