#ifndef N2NCCLIENTINFO_H
#define N2NCCLIENTINFO_H

#include "nixsys.h"
#include "rsa.h"
#include "socket.h"
#include "socketaddress.h"
#include "resolver.h"

#define N2NCCLIENTINFO_CLIENT_TIMEOUT 1000

using namespace n2nc ;

namespace n2nc {

/**
	@author fabsoft <fabsoft@gmail.com>
*/
class ClientInfo{
  public:
  
    typedef u_int32_t ClientID ;
    
    ClientInfo(ClientID id, net::Socket *sk);
    ~ClientInfo();
    
    ClientID getKeyID();
    
    /** Refresh the ack timestamp */
    time_t setAckTime();
    int setServicePort(uint16_t port);
    uint16_t getServicePort();
    net::Socket *getCtlSock() ;
    net::SocketAddress *getSrvSocketAddr();
    
    
    
    /** @return true if the client is currently online, false if the client timeout is expired */
    bool checkStatus();
    
    
  private:
    /* for future use. can be used to check the validity of the peer's rsa publick key. */
    n2nc::security::Rsa *m_rsakey ;
    time_t m_last_ack_time ;
    uint16_t m_sport ;
    net::Socket *m_ctlsk ;
    net::SocketAddress *m_srv_sockaddr ;
    ClientID m_id ; /* FIXME remove me */
};

}

#endif
