#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include "nixsys.h"
#include "argumentshelper.h"

using namespace n2nc::utils::args ;
using namespace std;

int main(int argc, char *argv[])
{
  ArgumentsHelper args(argv, argc) ;
  ValidArgument* t_val ;
  t_val = args.addValid("-arg1");
  t_val->comment = "argname_comment" ;
  t_val->dependsof.push_back("-arg2") ;
  t_val->paramlist.push_back("2") ;
  t_val->paramrequired = true ;
  
  t_val = args.addValid("-arg2");
  
  t_val = args.addValid("-arg3");
  t_val->paramlist.push_back("3");
  t_val->paramlist.push_back("paramfor_arg3");
  t_val->defaultparam = "defaultparam" ;
  
  if (args["-arg2"])
    cerr << args["-arg2"]->param() << endl ;
  
  if (args["-arg3"])
    cerr << args["-arg3"]->param() << endl ;
  
  cerr << args.dumpAllValid() ;
  cerr << args.toString() << endl ;
  cerr << "free arg " << args.getFreeArg(0) << endl ;
  cerr << "valid?: " << args.validate() << endl ;


  
  return EXIT_SUCCESS;
}
