#include "condition.h"

namespace n2nc {
namespace sync {

Condition::Condition(Mutex &mutex) : m_mutex(mutex) {

}

bool n2nc::sync::Condition::wait(){
  /** Check if the thread has acquired the lock */
  if (::pthread_mutex_trylock(& this->m_mutex.m_mutex) != EBUSY){
    /** error */
    ::pthread_mutex_unlock(& this->m_mutex.m_mutex);
    std::cerr << "Condition would wait outside a lock" << std::endl ;
    exit(1);
    return false ;
  }else{
    return !::pthread_cond_wait(&this->m_cond,&this->m_mutex.m_mutex);
  }

}

bool n2nc::sync::Condition::signal(){
    return !::pthread_cond_signal(&this->m_cond);
}

Condition::~Condition(){
}


}
}


