#include "ip4address.h"

namespace n2nc {
namespace net {

IP4Address::IP4Address() : Address()
{
  m_af=AF_INET;

}

IP4Address::IP4Address(std::string &addr) : Address()
{
  Address* ret ;
//   std::cerr << "hello IPV4. respwawn resolver" << std::endl ;
  ret = n2nc::net::Resolver::getAddressByFQDN(addr,false);
  if(!ret) {
    //error here
    throw ;
  }
  this->m_addr = ((IP4Address*)ret)->m_addr ;
  this->m_af=AF_INET;
  delete ret;
}

IP4Address::IP4Address(struct in_addr *addr) : Address()
{
  
//   std::cerr << "hello IPV4 " << std::endl ;
  this->m_af=AF_INET;
  this->m_addr = *addr ;
}



std::string IP4Address::toString() const{
  struct sockaddr_in t_addr;
  char s_ip[16];  /* xxx.xxx.xxx.xxx (15 + nullchar) */
  int ret ;
  memset(&t_addr,0, sizeof(t_addr));
  t_addr.sin_addr = this->m_addr ;
  t_addr.sin_family = AF_INET ;
  ret = getnameinfo((struct sockaddr*)&t_addr,sizeof(t_addr),s_ip,16,NULL,0,NI_NUMERICHOST);
  std::string ret_ip(s_ip);
  return ret_ip ;
}

void IP4Address::getRawAddress(void **addr,size_t *len){
  *addr = (void*)&((IP4Address*)this)->m_addr ;
  *len = sizeof(((IP4Address*)this)->m_addr);
}


IP4Address::~IP4Address()
{
}


}
}
