#include "ip6address.h"

namespace n2nc {
namespace net {

IP6Address::IP6Address() : Address()
{
  m_af=AF_INET6;
}

IP6Address::IP6Address(std::string &addr) : Address()
{
  Address* ret ;
  std::cerr << "hello IPV6. respwawn resolver" << addr << std::endl ;
  ret = n2nc::net::Resolver::getAddressByFQDN(addr,false);
  if(!ret) {
    //error here
    throw ;
  }
  this->m_addr = ((IP6Address*)ret)->m_addr ;
  this->m_af=AF_INET6;
  delete ret;
}

IP6Address::IP6Address(struct in6_addr *addr) : Address()
{
  
  std::cerr << "hello IPV6 " << std::endl ;
  this->m_af=AF_INET6;
  this->m_addr = *addr ;
}

std::string IP6Address::toString() const{
  struct sockaddr_in6 t_addr;
  char s_ip[63];  /* xxx.xxx.xxx.xxx (15 + nullchar) */
  memset(&t_addr,0, sizeof(t_addr));
  t_addr.sin6_addr = this->m_addr ;
  t_addr.sin6_family = AF_INET6 ;
  getnameinfo((struct sockaddr*)&t_addr,sizeof(t_addr),s_ip,63,NULL,0,NI_NUMERICHOST);
  std::string ret_ip(s_ip);
  return ret_ip ;
}


void IP6Address::getRawAddress(void **addr,size_t *len){
  *addr = (void*)&((IP6Address*)this)->m_addr ;
  *len = sizeof(((IP6Address*)this)->m_addr);
}

IP6Address::~IP6Address()
{
}


}
}
