#include "mutex.h"

namespace n2nc {
namespace sync {

Mutex::Mutex(){
  ::pthread_mutex_init(&this->m_mutex,NULL);
}
Mutex::~Mutex(){
  this->unlock();
}

bool Mutex::lock(){
  if (pthread_equal(this->m_lock_from,pthread_self())){
    /* deadlock detected */
    std::cerr << "deadlock detected, avoiding it:)" << std::endl ;
    return 0;
  }
  this->m_lock_from = pthread_self();
  return !::pthread_mutex_lock(&this->m_mutex);
}

bool Mutex::trylock(){
  return !::pthread_mutex_trylock(&this->m_mutex);
}

bool Mutex::unlock(){
  this->m_lock_from = 0;
  return !::pthread_mutex_unlock(&this->m_mutex);
}

}
}

