#include "tcpsocket.h"

namespace n2nc {
namespace net {

TcpSocket::TcpSocket(int af) : Socket(af,SOCK_STREAM){}
TcpSocket::TcpSocket() : Socket(){}
TcpSocket::~TcpSocket() {}

int TcpSocket::setListen(int backlog){
  this->setSockOpt(SO_REUSEADDR, true, SOL_SOCKET);
  int ret = ::listen(this->m_fd,backlog);
  if (ret == -1){
    N2NC_PRINT("listen_error: %s\n",strerror(errno) );
  }
  else{
    this->m_islisten = true ;
  }
  return ret;
}

Socket* TcpSocket::accept(){
  /** cleanest way. i should fit sockaddr directly by getRawSockAddr() but i prefer a local copy and use constructor */
  struct sockaddr_storage ss;
  size_t len = sizeof(ss) ;
  int sock;
  TcpSocket *obj_sock ;
  memset(&ss,0, sizeof(ss));
  sock = ::accept(this->m_fd,(struct sockaddr*)&ss,&len);
/** this address can be gathered from getpeername() */
  if (sock == -1){
    /** FIXME all in this context: check for EAGAIN */
    N2NC_PRINT("accept_error: %s\n",strerror(errno) );
    return NULL ;
  }

  obj_sock = new TcpSocket();
  obj_sock->m_type = this->m_type ;
  obj_sock->m_fd = sock ;
  obj_sock->m_af = this->m_af ;
  obj_sock->m_islisten = false ;

  return obj_sock;
}

bool TcpSocket::isListen(){
  return this->m_islisten ;
}


}
}
