#include "filteradapter.h"

namespace n2nc {

FilterAdapter::FilterAdapter(net::Socket& socket) : m_socket(socket){
  this->m_tmpbuf = malloc(65535);
}


FilterAdapter::~FilterAdapter(){
  free (this->m_tmpbuf);
}

bool FilterAdapter::addFilter(Filter* filter){
  this->m_filters.push_back(filter);
}

bool FilterAdapter::delFilter(Filter* filter){

}

int FilterAdapter::send(void * buf, size_t len){
  std::vector<Filter*>::iterator it;
  Filter *f;
  Filter::status_t stat ;
  void *inbuf, *outbuf ;
  size_t inlen ,outlen;
  inbuf = buf ;  inlen =len ;
  outbuf = this->m_tmpbuf ;
  /* */
  
  for( it = this->m_filters.begin() ; it != this->m_filters.end() ; it++){
    f = *it ;
    stat = f->egress(inbuf,outbuf,inlen,&outlen);
    inbuf = outbuf ;
    inlen = outlen ;
    switch(stat){
      case (Filter::FILTER_RETURN):
        goto exitchain ;
        break;
    
      case (Filter::FILTER_DROP):
        return -1 ;
        break;
    
      case (Filter::FILTER_CONTINUE):
        /*normal case, continue the chain */
        
        break;
    }
  }

exitchain:
  /*inject the public header */
  if (this->m_filters.empty()){
    return this->m_socket.send(inbuf,len);
  }
  return this->m_socket.send(outbuf,outlen);
}

int FilterAdapter::recv(void * buf, size_t len){
  std::vector<Filter*>::reverse_iterator it;
  Filter *f;
  Filter::status_t stat ;
  void *inbuf, *outbuf ;
  size_t inlen ,outlen;
  inbuf = this->m_tmpbuf ;  inlen =len ;
  outbuf = buf ;
  
  
  if (this->m_filters.empty()){
    inbuf = buf ;
  }
  inlen = this->m_socket.recv(inbuf,len); /* m_socket is PacketManager */
  outlen = inlen ; /* in case of no plugins */
  if (inlen < 0)  return -1 ;
  /* reverse order */
  for( it = this->m_filters.rbegin() ; it < this->m_filters.rend() ; ++it){
    f = *it ;
    stat = f->ingress(inbuf,outbuf,inlen,&outlen);
    inbuf = outbuf ;
    inlen = outlen ;
    switch(stat){
      case (Filter::FILTER_RETURN):
        goto exitchain ;
        break;
    
      case (Filter::FILTER_DROP):
        return -1 ;
        break;
    
      case (Filter::FILTER_CONTINUE):
        /*normal case, continue the chain */
        
        break;
    }
  }

exitchain:
  /*inject the public header */
  return outlen;
}


}


