#ifndef N2NCFILTERADAPTER_H
#define N2NCFILTERADAPTER_H
#include "nixsys.h"
#include "socket.h"
#include "filter.h" /* note that filter include n2nc.h */

namespace n2nc {

/**
  \brief This class provides the filter chain to be applied to a Socket

  @author fabsoft <fabsoft@gmail.com>
*/
class FilterAdapter {
  public:
    FilterAdapter(net::Socket& socket);
    ~FilterAdapter();
    bool addFilter(Filter* filter);
    bool delFilter(Filter* filter);
    int send(void *buf,size_t len);
    int recv(void *buf,size_t len);

  private:
    std::vector<Filter*> m_filters ;
    net::Socket& m_socket ;
    void *m_tmpbuf ;
};


}

#endif
