#include "blowfish.h"

namespace n2nc {
namespace security {

BlowFish::BlowFish(key_t *key) {
  this->loadKey(key);
//   EVP_CIPHER_CTX_init ( &this->m_ctx_e );
//   EVP_CIPHER_CTX_init ( &this->m_ctx_d );
  this->reinit();
//   EVP_EncryptInit ( &this->m_ctx_e, EVP_bf_cbc (), this->m_key, this->m_iv );
//   EVP_DecryptInit ( &this->m_ctx_d, EVP_bf_cbc (), this->m_key, this->m_iv );

}

BlowFish::~BlowFish() {
  EVP_CIPHER_CTX_cleanup ( &this->m_ctx_e );
  EVP_CIPHER_CTX_cleanup ( &this->m_ctx_d );
}

int BlowFish::loadKey (key_t *key) {
  ::memcpy ( ( void* ) this->m_key, key->key, 16 );
  ::bzero(key->iv,8); /* FIXME */
  ::memcpy ( ( void* ) this->m_iv, key->iv, 8 );

  ::bzero(&this->nullkey,sizeof(key_t)); /* FIXME */

}


int n2nc::security::BlowFish::keyRand(key_t *key){
  int fd ;
  fd = ::open ( "/dev/random", O_RDONLY );
  ::read ( fd, ( void* ) key->key , 16 );
  return ::close ( fd );
}

int BlowFish::reinit(){
  EVP_EncryptInit ( &this->m_ctx_e, EVP_bf_cbc (), this->m_key, this->m_iv );
  EVP_DecryptInit ( &this->m_ctx_d, EVP_bf_cbc (), this->m_key, this->m_iv );
}

int BlowFish::encrypt ( void * inbuf, void * outbuf, size_t inlen ) {
  int olen, tlen = 0 ;
  int written = 0;

    if (inlen > 65535)  return -1 ;

    if ( EVP_EncryptUpdate ( &this->m_ctx_e, (u_char*) (uint)outbuf + written, &olen, (u_char*)inbuf, inlen ) != 1 ) {
      std::cerr << "BlowFish: error on EVP_EncryptUpdate:" << std::endl ;
      return -1;
    }

    if ( EVP_EncryptFinal ( &this->m_ctx_e,(u_char*)((uint)outbuf + written + olen), &tlen ) != 1 ) {
      std::cerr << "BlowFish: error on EVP_EncryptFinal:" << std::endl ;
      return -1;
    }
//     std::cerr << "BlowFish: EVP_EncryptFinal tlen:" << tlen << std::endl ;
    
    olen += tlen;
    written += olen ;
  
  return written;
}

int BlowFish::decrypt ( void * inbuf, void * outbuf, size_t inlen ) {
  int olen, tlen = 0;
  int written = 0;

    if (inlen > 65535)  return -1 ;

    if ( EVP_DecryptUpdate ( &this->m_ctx_d, (u_char*) (uint)outbuf + written, &olen, (u_char*)inbuf, inlen ) != 1 ) {
      std::cerr << "BlowFish: error on EVP_DecryptUpdate:" << std::endl ;
      return -1;
    }

    if ( EVP_DecryptFinal ( &this->m_ctx_d,(u_char*)((uint)outbuf + written + olen), &tlen ) != 1 ) {
      std::cerr << "BlowFish: error on EVP_DecryptFinal:" << std::endl ;
      return -1;
    }
    olen += tlen;
    written += olen ;
  
  return written;
}






}
}




