#ifndef N2NCFILTERBLOWFISH_H
#define N2NCFILTERBLOWFISH_H

#include "filter.h"
#include "blowfish.h"
#include "packetmanager.h"

using namespace n2nc ;

namespace n2nc {

/**
	@author fabsoft <fabsoft@gmail.com>
*/
class FilterBlowFish : public n2nc::Filter{
  public:
    FilterBlowFish();
    virtual ~FilterBlowFish();
    
    virtual Filter::status_t egress(void *inbuf, void *outbuf,size_t inlen,size_t *outlen) ;
    virtual Filter::status_t ingress(void *inbuf, void *outbuf,size_t inlen,size_t *outlen) ;
    
    struct bfheader_t{
      uint32_t                    n_seq ;     /*4 bytes */
//       uint32_t                    pad ;     /*4 bytes */
//       security::BlowFish::key_t   n_new_key ; /* 24 bytes */
    };
  
  private:
    bool loadBF();
    security::BlowFish *m_bf ;
    bool m_bf_loaded ;
    void *m_tmpbuf ;
};

}

#endif
