#ifndef N2NC_NETIP4ADDRESS_H
#define N2NC_NETIP4ADDRESS_H

#include "address.h"
#include "resolver.h"

namespace n2nc {
namespace net {

/**
  \brief Provides the IP version 4 address abstraction
  @author fabsoft <fabsoft@gmail.com>
*/
class IP4Address : public Address
{
  private:
    IP4Address();
  public:
    IP4Address(std::string &addr);
    IP4Address(struct in_addr *addr);
    ~IP4Address();
    
    virtual std::string toString() const;
    virtual void getRawAddress(void **addr,size_t *len);
//     virtual SocketAddress& getSocketAddress();

  private:
    struct in_addr m_addr;

  friend class Resolver ;

};

}
}

#endif
