#ifndef N2NC_NETIP6ADDRESS_H
#define N2NC_NETIP6ADDRESS_H

#include "address.h"
#include "resolver.h"

namespace n2nc {
namespace net {

/**
  \brief Provides the IP version 6 address abstraction

  @author fabsoft <fabsoft@gmail.com>
*/
class IP6Address : public Address
{
private:
    IP6Address();
public:
    IP6Address(std::string &addr);
    IP6Address(struct in6_addr *addr);
    ~IP6Address();
    
    virtual std::string toString() const;
    virtual void getRawAddress(void **addr,size_t *len);
//     virtual SocketAddress& getSocketAddress();

private:
    struct in6_addr m_addr;

friend class Resolver ;
};

}
}

#endif
