#ifndef N2NC_SYSTEMLOGGER_H
#define N2NC_SYSTEMLOGGER_H

#include "nixsys.h"
#include "mutex.h"

#define N2NC_OUT(str) n2nc::system::Logger::out(str)
#define N2NC_PRINT n2nc::system::Logger::print
#define N2NC_PRINT2 n2nc::system::Logger::print
#define LOGME n2nc::system::Logger::get
#define LOGMET n2nc::system::Logger::gett


// #include <iostream>
// #include <stdarg.h>
// #include <sstream>

namespace n2nc {
namespace system {

/**
  \brief Provides a thead-safe and reentrant logging facility

  more about logger
  @author fabsoft <fabsoft@gmail.com>
  FIXME thread-safety & reentrant compliance needed !
*/
class Logger{
public:
  Logger();
  ~Logger();

  static int out(std::string &str);
  static int out(std::string str);
  static int out(char *str);
  static void print(char *frm,...);
  Logger& operator<<(char *str);
  Logger& operator<<(std::string str);
  Logger& operator<<(std::string &str);
  
  /** @return the ostringstream logger */
  static std::ostringstream& get();
  /** @return the ostringstream logger with additional thread info */
  static std::ostringstream& gett();
  static std::ostringstream& flush();

  /** Debug log */
//   static std::ostringstream& dlog();
  /***/
  
  /** Debug output */
  static std::ostream& dlog();
  /** Debug output to stream os */
  static std::ostream& dlog(std::ostream &os);

  /** Insert a newline and Flush the stream. */
  typedef class endl_flush_t{/*int a;*/};
  /** Flush the stream. */
  typedef class flush_t{};
  
  static flush_t fl ;
  static endl_flush_t fendl ;


private:
  static sync::Mutex m_std_lock ;
  static sync::Mutex m_err_lock ;

  static bool m_isloaded ;
  static std::ostringstream m_os;
  static std::ostringstream m_cout/*()*/;
  static std::string m_logfile ;
  static Logger* m_glb_logger ;

// friend class std::ostringstream ;
  friend void operator<<(std::ostream&,Logger::endl_flush_t);
  friend void operator<<(std::ostream&,Logger::flush_t);

};
// void operator<<(std::ostream&,Logger::endl_t);




}
}

#endif
