#include "packetmanager.h"

namespace n2nc {

PacketManager::PacketManager(net::Socket *sk){
  this->m_sk = sk;
  this->m_sendbuf = ::malloc(65535);  /* FIXME use m_buf_dirty by socket base class instead */
  this->m_recvbuf = ::malloc(65535);  /* FIXME use m_buf_dirty by socket base class instead */
  bzero(&this->m_pklastsent,sizeof(srv_packet_header_t));
  bzero(&this->m_pklastrecvd,sizeof(srv_packet_header_t));
  totalsent = 0;
  totalrecvd = 0;
//   mps = MAX_MPS ;
}


PacketManager::~PacketManager(){
  ::free(this->m_sendbuf);
  ::free(this->m_recvbuf);
}

int PacketManager::send(void * buf, size_t len){
/* here come the payload from filters chain */
  srv_packet_header tosend ;
  bzero(&tosend,sizeof(tosend));
//   tosend = pklastsent;
  tosend.p_size = len ;
  tosend.p_seq = m_pklastsent.p_seq + 1;
  tosend.h_type = SRV_PK_DATA ;
  this->m_pklastsent = tosend ;
  /* injecting header */
  /* FIXME, i can enhance this */
  memcpy(this->m_sendbuf,&tosend,sizeof(srv_packet_header));
  /* injecting payload */
  memcpy((u_char*)this->m_sendbuf + sizeof(srv_packet_header),buf,len);
  
//   std::cerr << "pkm sending len: " << len + sizeof(srv_packet_header) << std::endl ;
  totalsent += len + sizeof(srv_packet_header) ;
//   std::cerr << "\tPKM.>>>>>>>> writing to sock, sockbuffer_len: " << len + sizeof(srv_packet_header) << std::endl ;
  return this->m_sk->send(this->m_sendbuf,len + sizeof(srv_packet_header));
  
}

int PacketManager::recv(void * buf, size_t len){
  int recvlen ;
  srv_packet_header recvpk ;
  recvlen = this->m_sk->recv(this->m_recvbuf,len);
  if (recvlen < 0)  return -1 ;
  totalrecvd += recvlen;
//   std::cerr << "\tPKM.<<<<<<<< reading from sock, sockbuffer_len: " << recvlen << std::endl ;
  
  if (recvlen < sizeof(srv_packet_header)) {
    std::cerr << "\tPKM.received data, but the packet lenght is to small. Discarding packet" << std:: endl ;
    return -1 ;
  }
  /* get the header */
  ::memcpy(&recvpk,this->m_recvbuf,sizeof(srv_packet_header));
  if ( recvpk.h_type != SRV_PK_DATA){
    std::cerr << "\tPKM.discarding packet, header doesn't match my pattern" << std:: endl ;
    return -1 ;
  }
  if (recvpk.p_size != (recvlen - sizeof(srv_packet_header))){
    std::cerr << "\tPKM.discarding packet, lenght mismatch. expected: " << recvpk.p_size << " read: " << recvlen - sizeof(srv_packet_header) << std:: endl ;
    return -1 ;
  }
  this->m_pklastrecvd = recvpk;
  memcpy(buf,(u_char*)this->m_recvbuf + sizeof(srv_packet_header),recvpk.p_size );
  return recvpk.p_size ;

}

PacketManager::srv_packet_header_t *PacketManager::getRecvPkHeader(){
  return &this->m_pklastrecvd ;
}

PacketManager::srv_packet_header_t *PacketManager::getSendPkHeader(){
  return &this->m_pklastsent ;
}

}







