#ifndef N2NCPACKETMANAGER_H
#define N2NCPACKETMANAGER_H

#include "nixsys.h"
#include "socket.h"

using namespace n2nc ;

namespace n2nc {
/**
	@author fabsoft <fabsoft@gmail.com>
*/
class PacketManager : public n2nc::net::Socket {
  public:
    PacketManager(net::Socket *sk);
    ~PacketManager();
    virtual int send(void *buf, size_t len);
    virtual int recv(void *buf, size_t len);
    
    struct srv_packet_header{
      int16_t  h_type ;
      int16_t  p_size ;
      int32_t  p_seq ;
    };
    enum srv_packet_type{
      SRV_PK_GARBAGE = 0,
      SRV_PK_GARBAGE_ACK,
      SRV_PK_DATA
    };
    typedef struct srv_packet_header srv_packet_header_t ;
    /* saves a copy of last header sent */
    srv_packet_header m_pklastsent ;
    /* saves a copy of last header received */
    srv_packet_header m_pklastrecvd ;
  
    srv_packet_header_t *getRecvPkHeader();
    srv_packet_header_t *getSendPkHeader();
    size_t mps ;  /**< maximum packet size */
    
    uint64_t totalsent ;
    uint64_t totalrecvd ;
  private:
    net::Socket *m_sk;
    void *m_sendbuf ;
    void *m_recvbuf ;

#define MAX_MSS 1472
#define MAX_MPS_1 (MAX_MSS - sizeof(n2nc::PacketManager::srv_packet_type) - sizeof(n2nc::FilterBlowFish::bfheader_t) )
#define MAX_MPS ((( (MAX_MPS_1 -1 ) / 8 ) ) * 8 )
/* align to a multiple of 8 bytes */
// #define MAX_MPS (MAX_MSS - sizeof(n2nc::PacketManager::srv_packet_type)) - ( (( sizeof(n2nc::FilterBlowFish::bfheader_t) / 8 ) + 2) * 8 )

};
}

#endif
