#ifndef N2NC_NETRESOLVER_H
#define N2NC_NETRESOLVER_H

#include "nixsys.h"
#include "address.h"
#include "ip4address.h"
#include "ip6address.h"
#include "socketaddress.h"
#include "logger.h"
// using namespace std;
namespace n2nc {
namespace net {

/**
  \brief This class provides various utilities to help about dns name resolver.
  @author fabsoft <fabsoft@gmail.com>
*/
class Resolver{
private:
    Resolver();
    ~Resolver();
public:
    /** @Return a new Address */
    static Address* getAddressByFQDN(std::string &addr,bool resolve=true);
    static SocketAddress* getSocketAddressByService(const std::string& fqdn,const std::string& port,int type=SOCK_STREAM,int af=AF_UNSPEC,bool resolve=false);
    static SocketAddress* getSocketAddressByService(const std::string& fqdn,const int port,int type=SOCK_STREAM,int af=AF_UNSPEC,bool resolve=false);
    static SocketAddress* getSocketAddressByService(const Address& addr,const int port,int type=SOCK_STREAM);
    static std::string& getFQDNbyAddress(Address &addr);
    
    static Address& getAddressByName(std::string &name, bool resolve=false);


};

}
}

#endif
