#ifndef N2NC_SECURITYRSA_H
#define N2NC_SECURITYRSA_H
#include "nixsys.h"

namespace n2nc {
namespace security {

/**
	@author fabsoft <fabsoft@gmail.com>
*/
class Rsa{
  public:
    Rsa();
    int loadPubFromFile(std::string filename);
    int loadPriFromFile(std::string filename);
    
    int encrypt(void *inbuf, void *outbuf, size_t inlen);
    int decrypt(void *inbuf, void *outbuf, size_t inlen);
    
    int genkey(std::string filename);
    
    
    ~Rsa();
    typedef uint32_t ID ;
    int getID();
  private:
  
    bool m_pub_isloaded ;
    bool m_pri_isloaded ;
    ::RSA *m_pub_rsa ;
    ::RSA *m_pri_rsa ;
};

}
}

#endif
