#ifndef N2NC_NETSOCKETADDRESS_H
#define N2NC_NETSOCKETADDRESS_H

#include "nixsys.h"
#include "address.h"

namespace n2nc {
namespace net {

class Address;
/**
  \brief socket address base class (similar to sockaddr_storage)

  @author fabsoft <fabsoft@gmail.com>
*/
class SocketAddress{
public:
    SocketAddress();
//     SocketAddress(Address &addr);
    /** Creates a new SocketAddress represented by sockaddr sa */
    SocketAddress(struct sockaddr* sa);
    SocketAddress(Address * addr, uint16_t port);
    
    ~SocketAddress();
    int getAddressFamily();
    struct sockaddr* getRawSockAddr();
    int getRawSockAddrLen();
    std::string toString();
    Address* getAddress();

    typedef sockaddr_storage Storage ;
private:
    struct sockaddr_storage m_sa ;
};

}
}

#endif
