#include "socketevents.h"

namespace n2nc {
namespace net {

SocketEvents::SocketEvents(){
  this->m_recvbuff = (char*)::malloc(65535);
}


SocketEvents::~SocketEvents(){
  free(this->m_recvbuff);
}

int SocketEvents::onSelectEvent(SocketEventsHandler::socket_extra_t* sock_extra, SocketEventsHandler::check_for_t cause ){
  int retval ;
  std::cerr << "onSelectEvent" << std::endl ;

  ///NOTE defaulting to get the socket disabled in select polling to avoid possible uncontrolled loops.
  sock_extra->check = (SocketEventsHandler::check_for_t) (sock_extra->check | SocketEventsHandler::NOTHING) ;
  int tmp_cause ;
  if(cause & SocketEventsHandler::READ){
    /* readable socket causes: close, read, error, new connection(on listen socket)  */
    if ((sock_extra->sock->getType() == SOCK_STREAM) && ((TcpSocket*)sock_extra->sock)->isListen() )
      this->onNewConnection(*sock_extra->sock);
    else{
      retval = ::recv(sock_extra->sock->getFD(), this->m_recvbuff, 65535, MSG_DONTWAIT | MSG_PEEK) ; /* leave the message on the kernel sk buffer */
      if (retval > 0)
        this->onReceive(*sock_extra->sock,retval);
      else{
        sock_extra->last_errno = errno ;
        this->onClose(*sock_extra->sock);
      }
    }
  }
  if(cause & SocketEventsHandler::WRITE){
    this->onWriteComplete(*sock_extra->sock);
  }
  if(cause & SocketEventsHandler::EXCEPT){
    this->onError(*sock_extra->sock);
  }
  return 0 ;
}


}

}

