#ifndef N2NC_NETSOCKETEVENTS_H
#define N2NC_NETSOCKETEVENTS_H

#include "socketeventshandler.h"
#include "tcpsocket.h"

namespace n2nc {
namespace net {
    
// class SocketEventsHandler ;
// class SocketEventsHandler::socket_extra_t ;

/**
  \brief Socket events to avoid explicits callbacks
  @author fabsoft <fabsoft@gmail.com>
*/
class SocketEvents{
  public:
    SocketEvents();
    ~SocketEvents();

  protected:
    
    virtual int onReceive(Socket& sock,int dtlen)=0;
    virtual int onNewConnection(Socket& sock)=0;
    
    virtual int onWriteComplete(Socket& sock)=0;
    
    virtual int onClose(Socket& sock)=0;
    virtual int onError(Socket& sock)=0;
    virtual int onRawReceive(Socket& sock)=0;
    
    
    /** when returns 0 */
//     class n2nc::net::SocketEventsHandler;
    virtual int onSelectEvent(SocketEventsHandler::socket_extra_t* sock_extra,SocketEventsHandler::check_for_t cause );
  
    private:
//       char m_recvbuff[65535];
      char *m_recvbuff;
    
  friend class SocketEventsHandler;

};

}

}

#endif
