#ifndef N2NCTRACKERCLIENT_H
#define N2NCTRACKERCLIENT_H

#include "nixsys.h"
#include "socket.h"
#include "socketaddress.h"
#include "network.h"

/* NOTE TrackerClient and Network have crossed include */
namespace n2nc {
/**
  \brief This class proviedes the code to connect and exchange commands to and from a TrackerServer

  \see TrackerServer
  @author fabsoft <fabsoft@gmail.com>
*/
class TrackerClient {
  public:
    TrackerClient();
    ~TrackerClient();
    /** Create a connection to the server tracker */
    /* TODO insert a credential manager here. */
    bool connect(const net::SocketAddress& address);
    /** Sends a command to the server tracker */
    bool sendCmd(std::string cmd);
    /** Receives a command from the server tracker */
    std::string recvCmd();

    /** Get Network by \a name */
    n2nc::Network& getNetwork(std::string name);
    enum command_t {
      JOIN_NET,
      PART_NET
    };
    
    bool createNetwork(std::string netname);
  
  private:
    net::Socket *m_socket ;
};

}

#endif
