#ifndef N2NCTRAVERSAL_H
#define N2NCTRAVERSAL_H

#define TRVERSAL_UDP_HOLE_PUNCHING_CONST  0
#define TRVERSAL_RELAY_CONST              1
#define TRVERSAL_UPNP_CONST               2
#define TRVERSAL_DIRECT                   3

#include "nixsys.h"
#include "socket.h"
#include "network.h"

namespace n2nc {

/**
  \brief This class provides the base interface to transport NAT traversal procedures.
  
  More on traversal
  @author fabsoft <fabsoft@gmail.com>
  
  continued description
*/
class Traversal{
  public:
    /* FIXME adjust acl */
    virtual ~Traversal();
    /** Enumeration for choice the traversal method */
    enum method_t{
      UDP_HOLE_PUNCHING = TRVERSAL_UDP_HOLE_PUNCHING_CONST, /**< Udp Hole Punching method */
      RELAY_CONST = TRVERSAL_RELAY_CONST, /**< Relay method */
      UPNP_CONST = TRVERSAL_UPNP_CONST, /**< Upnp method */
      DIRECT = TRVERSAL_DIRECT /**< Direct connection(dummy) method */
    };

    /** Performs a connection to Network \a net FIXME if error ?*/
    virtual net::Socket& doConnect(Network& net) = 0 ;
    /** Default factory method to get a new Traversal Method */
    Traversal& getTraversal(method_t method);
  protected:
    Traversal();

};

}//ns

#endif
