#ifndef N2NC_UTILS_ARGSVALIDARGUMENT_H
#define N2NC_UTILS_ARGSVALIDARGUMENT_H

#include "nixsys.h"

namespace n2nc {
namespace utils {
namespace args {

using namespace std ;
/**
  \brief This class represents a expected argument

  @author fabsoft <fabsoft@gmail.com>
*/
class ValidArgument{
  public:
    ValidArgument(string name);
//     ValidArgument(const ValidArgument& obj);
//     ValidArgument(const ValidArgument& validarg);
    ~ValidArgument();
    
    string toString();
    static ValidArgument* find(string name,vector<ValidArgument>& valids);
    /* members */
    /* FIXME acl */
    /** Indicates if a parameter is mandatory. */
    bool paramrequired ;
    /** The name of argument.*/
    std::string name ;
    /** The comment to be displayed by ArgumentsHelper::dumpAllValid() */
    std::string comment ;
    /** If the param is not required and a a parameter is not supplied the assuming \a defaultparam */
    std::string defaultparam ;
    /** A list of expected parameters for this argument. */
    std::vector<std::string> paramlist ;
    /** A list of expected patternized parameters for this argument. */
    std::vector<std::string> paramlist_pattern ;
    /** A list of dependant arguments(name) for this argument. */
    std::vector<std::string> dependsof ;
    /** A list of conlictual arguments(name) for this argument. */
    std::vector<std::string> conflictsto ;
  
//   friend class ArgumentsHelper ;

};

/**
 * \brief Join a vector of strings into a string
  
  Joins all strings in the vector \a sl into 
  the returned string, separated by \a delimiter
 * @return The joined string
 */
string explode(vector<string>& sl, string delimiter);


}
}
}

#endif
